From 27addc6855d83a50adea9d41bfe1ead3f8f7eb9e Mon Sep 17 00:00:00 2001
From: Raphael Geissert <geissert@debian.org>
Date: Mon, 19 Dec 2016 15:10:23 +0100
Subject: [PATCH] Add a --fix-only option

---
 unattended-upgrade |    9 ++++++++-
 1 files changed, 8 insertions(+), 1 deletions(-)

diff --git a/unattended-upgrade b/unattended-upgrade
index e68d3e9..3a194d6 100755
--- a/unattended-upgrade
+++ b/unattended-upgrade
@@ -1197,7 +1197,7 @@ def main(options, rootdir=""):
     mem_log = _setup_logging(options)
 
     # check if today is a patch day
-    if not is_update_day():
+    if not is_update_day() and not options.fix_only:
         return
 
     # format (origin, archive), e.g. ("Ubuntu","dapper-security")
@@ -1249,6 +1249,10 @@ def main(options, rootdir=""):
             logging.debug("Unclean dpkg state, but locked, another package "
                           "manager working?")
 
+    if options.fix_only:
+        logging.info("Option --fix-only given, *not* doing anything else")
+        return
+
     # check and get lock
     try:
         apt_pkg.pkgsystem_lock()
@@ -1516,6 +1520,9 @@ if __name__ == "__main__":
     parser.add_option("", "--dry-run",
                       action="store_true", default=False,
                       help=_("Simulation, download but do not install"))
+    parser.add_option("", "--fix-only",
+                      action="store_true", default=False,
+                      help=_("Fix the dpkg database if needed, do not download nor install"))
     parser.add_option("", "--minimal-upgrade-steps",
                       action="store_true", default=False,
                       help=_("Upgrade in minimal steps (and allow "
-- 
1.7.2.5

